package com.framsticks.util.dispatching;

import com.framsticks.util.StateFunctor;

/**
 * @author Piotr Sniegowski
 */
public abstract class Dispatching {

	public static boolean isThreadSafe() {
		return true;
	}

	public static <C> void invokeLaterOrNow(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
		if (dispatcher.isActive()) {
			runnable.run();
			return;
		}
		dispatcher.invokeLater(runnable);
	}

	//TODO RunAt StateFunctor
	public static <C> void dispatchOk(Dispatcher<C> dispatcher, final StateFunctor stateFunctor) {
		dispatcher.invokeLater(new RunAt<C>() {
			@Override
			public void run() {
				stateFunctor.call(null);
			}
		});
	}

	// public static boolean assertInvokeLater(Dispatcher dispatcher, RunAt runnable) {
	// 	dispatcher.invokeLater(runnable);
	// 	return true;
	// }

	public static <P, C> void invokeDispatch(Dispatcher<P> dispatcher, final Dispatcher<C> finalDispatcher, final RunAt<C> runnable) {
		dispatcher.invokeLater(new RunAt<P>() {
			@Override
			public void run() {
				finalDispatcher.invokeLater(runnable);
			}
		});
	}

}
